﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Adaptiv4RoundDestinguisher {
    public partial class Form1 : Form {
                
        string[,] subByteTable = new string[16, 16] {
            // 0     1     2     3     4     5     6     7     8     9     a     b     c     d     e     f
            { "63",	"7c", "77",	"7b", "f2",	"6b", "6f", "c5", "30", "01", "67", "2b", "fe", "d7", "ab",	"76" },// 0
            { "ca", "82", "c9",	"7d", "fa",	"59", "47",	"f0", "ad",	"d4", "a2", "af", "9c",	"a4", "72",	"c0" },// 1
            { "b7",	"fd", "93",	"26", "36",	"3f", "f7",	"cc", "34",	"a5", "e5",	"f1", "71",	"d8", "31",	"15" },// 2
            { "04",	"c7", "23", "c3", "18", "96", "05", "9a", "07", "12", "80", "e2", "eb", "27", "b2", "75" },// 3
            { "09",	"83", "2c", "1a", "1b", "6e", "5a", "a0", "52", "3b", "d6", "b3", "29", "e3", "2f", "84" },// 4
            { "53",	"d1", "00",	"ed", "20", "fc", "b1", "5b", "6a", "cb", "be",	"39", "4a", "4c", "58", "cf" },// 5
            { "d0", "ef", "aa",	"fb", "43",	"4d", "33",	"85", "45",	"f9", "02",	"7f", "50",	"3c", "9f",	"a8" },// 6
            { "51",	"a3", "40",	"8f", "92",	"9d", "38",	"f5", "bc",	"b6", "da",	"21", "10",	"ff", "f3",	"d2" },// 7
            { "cd",	"0c", "13",	"ec", "5f",	"97", "44",	"17", "c4",	"a7", "7e",	"3d", "64",	"5d", "19",	"73" },// 8
            { "60", "81", "4f",	"dc", "22",	"2a", "90",	"88", "46",	"ee", "b8",	"14", "de",	"5e", "0b",	"db" },// 9
            { "e0",	"32", "3a",	"0a", "49",	"06", "24",	"5c", "c2",	"d3", "ac",	"62", "91",	"95", "e4",	"79" },// a
            { "e7",	"c8", "37",	"6d", "8d",	"d5", "4e",	"a9", "6c",	"56", "f4",	"ea", "65",	"7a", "ae",	"08" },// b
            { "ba",	"78", "25",	"2e", "1c",	"a6", "b4",	"c6", "e8",	"dd", "74",	"1f", "4b",	"bd", "8b",	"8a" },// c
            { "70",	"3e", "b5",	"66", "48",	"03", "f6",	"0e", "61",	"35", "57",	"b9", "86",	"c1", "1d",	"9e" },// d
            { "e1",	"f8", "98",	"11", "69",	"d9", "8e",	"94", "9b",	"1e", "87",	"e9", "ce",	"55", "28",	"df" },// e
            { "8c",	"a1", "89",	"0d", "bf",	"e6", "42",	"68", "41",	"99", "2d",	"0f", "b0",	"54", "bb",	"16" } // f            
        };        
        string[,] inverseSubByteTable = new string[16, 16] {
            // 0     1     2     3     4     5     6     7     8     9     a     b     c     d     e     f
            { "52", "09", "6a", "d5", "30", "36", "a5", "38", "bf", "40", "a3", "9e", "81", "f3", "d7", "fb" }, //0
            { "7c", "e3", "39", "82", "9b", "2f", "ff", "87", "34", "8e", "43", "44", "c4", "de", "e9", "cb" }, //1
            { "54", "7b", "94", "32", "a6", "c2", "23", "3d", "ee", "4c", "95", "0b", "42", "fa", "c3", "4e" }, //2
            { "08",	"2e", "a1",	"66", "28",	"d9", "24", "b2", "76",	"5b", "a2",	"49", "6d",	"8b", "d1",	"25" }, //3
            { "72",	"f8", "f6",	"64", "86",	"68", "98",	"16", "d4",	"a4", "5c",	"cc", "5d",	"65", "b6",	"92" }, //4
            { "6c",	"70", "48",	"50", "fd",	"ed", "b9",	"da", "5e",	"15", "46",	"57", "a7",	"8d", "9d",	"84" }, //5
            { "90",	"d8", "ab",	"00", "8c",	"bc", "d3",	"0a", "f7",	"e4", "58",	"05", "b8",	"b3", "45",	"06" }, //6
            { "d0",	"2c", "1e",	"8f", "ca",	"3f", "0f",	"02", "c1",	"af", "bd",	"03", "01",	"13", "8a",	"6b" }, //7
            { "3a",	"91", "11",	"41", "4f",	"67", "dc",	"ea", "97",	"f2", "cf",	"ce", "f0",	"b4", "e6",	"73" }, //8
            { "96",	"ac", "74",	"22", "e7",	"ad", "35",	"85", "e2",	"f9", "37",	"e8", "1c",	"75", "df",	"6e" }, //9
            { "47",	"f1", "1a",	"71", "1d",	"29", "c5",	"89", "6f",	"b7", "62",	"0e", "aa",	"18", "be",	"1b" }, //a
            { "fc",	"56", "3e",	"4b", "c6",	"d2", "79",	"20", "9a",	"db", "c0",	"fe", "78",	"cd", "5a",	"f4" }, //b
            { "1f",	"dd", "a8",	"33", "88",	"07", "c7",	"31", "b1",	"12", "10",	"59", "27",	"80", "ec",	"5f" }, //c
            { "60",	"51", "7f",	"a9", "19",	"b5", "4a",	"0d", "2d",	"e5", "7a",	"9f", "93",	"c9", "9c",	"ef" }, //d
            { "a0",	"e0", "3b",	"4d", "ae",	"2a", "f5",	"b0", "c8",	"eb", "bb",	"3c", "83",	"53", "99",	"61" }, //e
            { "17",	"2b", "04",	"7e", "ba",	"77", "d6",	"26", "e1",	"69", "14",	"63", "55",	"21", "0c",	"7d" }  //f
        };
        string[,] Rcon = new string[4, 10] {
            { "01", "02", "04", "08", "10", "20", "40", "80", "1b", "36" },
            { "00", "00", "00", "00", "00", "00", "00", "00", "00", "00" },
            { "00", "00", "00", "00", "00", "00", "00", "00", "00", "00" },
            { "00", "00", "00", "00", "00", "00", "00", "00", "00", "00" }
        };

        // Global Variables ---------------------------------------------------------------------------------------------------        
        string[] p1Arr = new string[16]; string[] p2Arr = new string[16];
        string[] c1Arr = new string[16]; string[] c2Arr = new string[16];
        string[] p1_markArr = new string[16]; string[] p2_markArr = new string[16];
        string[] c1_markArr = new string[16]; string[] c2_markArr = new string[16];
        string[] keyArr = new string[16];

        string[] rcon0 = new string[4]; string[] rcon1 = new string[4]; string[] rcon2 = new string[4]; string[] rcon3 = new string[4]; string[] rcon4 = new string[4]; string[] rcon5 = new string[4]; string[] rcon6 = new string[4]; string[] rcon7 = new string[4]; string[] rcon8 = new string[4]; string[] rcon9 = new string[4];
        string[] p1RK1 = new string[16]; string[] p1RK2 = new string[16]; string[] p1RK3 = new string[16]; string[] p1RK4 = new string[16]; string[] p1RK5 = new string[16]; string[] p1RK6 = new string[16]; string[] p1RK7 = new string[16]; string[] p1RK8 = new string[16]; string[] p1RK9 = new string[16]; string[] p1RK10 = new string[16];
        string[] p2RK1 = new string[16]; string[] p2RK2 = new string[16]; string[] p2RK3 = new string[16]; string[] p2RK4 = new string[16]; string[] p2RK5 = new string[16]; string[] p2RK6 = new string[16]; string[] p2RK7 = new string[16]; string[] p2RK8 = new string[16]; string[] p2RK9 = new string[16]; string[] p2RK10 = new string[16];

        List<string[]> rconList = new List<string[]>();
        List<string[]> roundKeyList = new List<string[]>();
        
        int roundCounter = 0;
        uint diagonal1GeneratorCounter = 0;
        uint diagonal2GeneratorCounter = 0;
        string[] mix = new string[16];
        string[] p1State = new string[16];
        string[] p2State = new string[16];
        string[] c1State = new string[16];
        string[] c2State = new string[16];
        //#########################################################################################################################
        

        public Form1() {
            InitializeComponent();
            for (int i = 0; i < 4; i++) { rcon0[i] = Rcon[i, 0]; }
            for (int i = 0; i < 4; i++) { rcon1[i] = Rcon[i, 1]; }
            for (int i = 0; i < 4; i++) { rcon2[i] = Rcon[i, 2]; }
            for (int i = 0; i < 4; i++) { rcon3[i] = Rcon[i, 3]; }
            for (int i = 0; i < 4; i++) { rcon4[i] = Rcon[i, 4]; }
            for (int i = 0; i < 4; i++) { rcon5[i] = Rcon[i, 5]; }
            for (int i = 0; i < 4; i++) { rcon6[i] = Rcon[i, 6]; }
            for (int i = 0; i < 4; i++) { rcon7[i] = Rcon[i, 7]; }
            for (int i = 0; i < 4; i++) { rcon8[i] = Rcon[i, 8]; }
            for (int i = 0; i < 4; i++) { rcon9[i] = Rcon[i, 9]; }
            rconList.Add(rcon0); rconList.Add(rcon1); rconList.Add(rcon2); rconList.Add(rcon3); rconList.Add(rcon4); rconList.Add(rcon5); rconList.Add(rcon6); rconList.Add(rcon7); rconList.Add(rcon8); rconList.Add(rcon9);
        }
        // General functions --------------------------------------------------------------
        private bool IsValidInput(string s) { if (s.Length == 32) { return System.Text.RegularExpressions.Regex.IsMatch(s, @"\A\b[0-9a-fA-F]+\b\Z"); } else return false; }
        private string[] initStringArray(string s) { string[] stringArr = new string[16]; if (s.Length != 32) { MessageBox.Show("String must be 32 char's"); return new string[16]; } else { int j = 0; for (int i = 0; i < 16; i++) { stringArr[i] = s.Substring(j, 2); j += 2; } return stringArr; } }
        private string[] init32BitStringArray(string s) { string[] stringArr = new string[4]; if (s.Length != 8) { MessageBox.Show("String must be 32 bit (4 char's)"); return new string[4]; } else { int j = 0; for (int i = 0; i < 4; i++) { stringArr[i] = s.Substring(j, 2).ToLower(); j += 2; } return stringArr; } }
        
        private int stringToInt(string s) { return Convert.ToInt16(s); }
        private string intToBin(int _int) { return Convert.ToString(_int, 2).PadLeft(8, '0'); }
        private string intToHex(int _int) { return _int.ToString("X").PadLeft(2, '0'); }
        private string uintToHex(uint _uint) { return _uint.ToString("X").PadLeft(8, '0'); }
        private int binToInt(string _bin) { return Convert.ToInt16(_bin, 2); }        
        private string binToHex(string _bin) { return Convert.ToInt16(_bin, 2).ToString("X").PadLeft(2, '0').ToLower(); }
        private int hexToInt(string _hex) { return int.Parse(_hex, System.Globalization.NumberStyles.HexNumber); }
        private string hexToBin(string _hex) { return intToBin(Convert.ToInt32(_hex, 16)).PadLeft(8, '0'); }
        private string LeftShift(string s) { string tmp = s.Remove(0, 1); return tmp + "0"; }
        private bool LeftmostIsOne(string s) { if (s[0] == '1') { return true; } else { return false; } }
        private string XOR(string s1, string s2) { string result = ""; for (int i = 0; i < 8; i++) { if (s1[i] == '0' && s2[i] == '0') { result += "0"; } else if (s1[i] == '0' && s2[i] == '1') { result += "1"; } else if (s1[i] == '1' && s2[i] == '0') { result += "1"; } else if (s1[i] == '1' && s2[i] == '1') { result += "0"; } } return result; }
        private string[] xor4x1Arr(string[] arr1, string[] arr2) { string[] resultArr = new string[4]; for (int i = 0; i < 4; i++) { string arr1Bin = hexToBin(arr1[i]); string arr2Bin = hexToBin(arr2[i]); resultArr[i] = binToHex(XOR(arr1Bin, arr2Bin)); } return resultArr; }
        private string[] xor4x4Arr(string[] arr1, string[] arr2) { string[] resultArr = new string[16]; for (int i = 0; i < 16; i++) { string arr1Bin = hexToBin(arr1[i]); string arr2Bin = hexToBin(arr2[i]); resultArr[i] = binToHex(XOR(arr1Bin, arr2Bin)); } return resultArr; }
        private string Times02(string s) { string result = ""; if (LeftmostIsOne(s)) { string tmp = LeftShift(s); result = XOR(tmp, "00011011"); } else { result = LeftShift(s); } return result; }
        private string Times03(string s) { return XOR(s, Times02(s)); }
        private string Times09(string s) { return XOR(Times02(Times02(Times02(s))), s); }         //x × 9 = (((x×2)×2)×2)+x
        private string Times11(string s) { return XOR(Times02(XOR(s, Times02(Times02(s)))), s); } //x × 11 = ((((x×2)×2)+x)×2)+x
        private string Times13(string s) { return XOR(Times02(Times02(XOR(Times02(s), s))), s); } //x × 13=((((x×2)+x)×2)×2)+x
        private string Times14(string s) { return Times02(XOR(Times02(XOR(Times02(s), s)), s)); } //x × 14 = ((((x×2)+x)×2)+x)×2
        // Display --------------------------------------------------------------------------------------------------------------
        private string printArr(string[] arr) { string result = ""; foreach (string s in arr) { result += s; } return result; }
        private void printMatrix(string[] arr) {            
            textBoxConsole.AppendText("\r\n");
            textBoxConsole.AppendText("---------------\r\n");
            textBoxConsole.AppendText(String.Format("| {0} {1} {2} {3} |\r\n", arr[00], arr[04], arr[08], arr[12]));
            textBoxConsole.AppendText(String.Format("| {0} {1} {2} {3} |\r\n", arr[01], arr[05], arr[09], arr[13]));
            textBoxConsole.AppendText(String.Format("| {0} {1} {2} {3} |\r\n", arr[02], arr[06], arr[10], arr[14]));
            textBoxConsole.AppendText(String.Format("| {0} {1} {2} {3} |\r\n", arr[03], arr[07], arr[11], arr[15]));
            textBoxConsole.AppendText("---------------\r\n");
        }
        private void DisplayP1(string[] sArr) { tbP1_1.Text = Convert.ToString(sArr[0]); tbP1_2.Text = Convert.ToString(sArr[1]); tbP1_3.Text = Convert.ToString(sArr[2]); tbP1_4.Text = Convert.ToString(sArr[3]); tbP1_5.Text = Convert.ToString(sArr[4]); tbP1_6.Text = Convert.ToString(sArr[5]); tbP1_7.Text = Convert.ToString(sArr[6]); tbP1_8.Text = Convert.ToString(sArr[7]); tbP1_9.Text = Convert.ToString(sArr[8]); tbP1_10.Text = Convert.ToString(sArr[9]); tbP1_11.Text = Convert.ToString(sArr[10]); tbP1_12.Text = Convert.ToString(sArr[11]); tbP1_13.Text = Convert.ToString(sArr[12]); tbP1_14.Text = Convert.ToString(sArr[13]); tbP1_15.Text = Convert.ToString(sArr[14]); tbP1_16.Text = Convert.ToString(sArr[15]); }
        private void DisplayP1_start(string[] sArr) { tbP1_start1.Text = Convert.ToString(sArr[0]); tbP1_start2.Text = Convert.ToString(sArr[1]); tbP1_start3.Text = Convert.ToString(sArr[2]); tbP1_start4.Text = Convert.ToString(sArr[3]); tbP1_start5.Text = Convert.ToString(sArr[4]); tbP1_start6.Text = Convert.ToString(sArr[5]); tbP1_start7.Text = Convert.ToString(sArr[6]); tbP1_start8.Text = Convert.ToString(sArr[7]); tbP1_start9.Text = Convert.ToString(sArr[8]); tbP1_start10.Text = Convert.ToString(sArr[9]); tbP1_start11.Text = Convert.ToString(sArr[10]); tbP1_start12.Text = Convert.ToString(sArr[11]); tbP1_start13.Text = Convert.ToString(sArr[12]); tbP1_start14.Text = Convert.ToString(sArr[13]); tbP1_start15.Text = Convert.ToString(sArr[14]); tbP1_start16.Text = Convert.ToString(sArr[15]); }
        private void DisplayP1_ASB(string[] sArr) { tbP1_ASB1.Text = Convert.ToString(sArr[0]); tbP1_ASB2.Text = Convert.ToString(sArr[1]); tbP1_ASB3.Text = Convert.ToString(sArr[2]); tbP1_ASB4.Text = Convert.ToString(sArr[3]); tbP1_ASB5.Text = Convert.ToString(sArr[4]); tbP1_ASB6.Text = Convert.ToString(sArr[5]); tbP1_ASB7.Text = Convert.ToString(sArr[6]); tbP1_ASB8.Text = Convert.ToString(sArr[7]); tbP1_ASB9.Text = Convert.ToString(sArr[8]); tbP1_ASB10.Text = Convert.ToString(sArr[9]); tbP1_ASB11.Text = Convert.ToString(sArr[10]); tbP1_ASB12.Text = Convert.ToString(sArr[11]); tbP1_ASB13.Text = Convert.ToString(sArr[12]); tbP1_ASB14.Text = Convert.ToString(sArr[13]); tbP1_ASB15.Text = Convert.ToString(sArr[14]); tbP1_ASB16.Text = Convert.ToString(sArr[15]); }
        private void DisplayP1_ASR(string[] sArr) { tbP1_ASR1.Text = Convert.ToString(sArr[0]); tbP1_ASR2.Text = Convert.ToString(sArr[1]); tbP1_ASR3.Text = Convert.ToString(sArr[2]); tbP1_ASR4.Text = Convert.ToString(sArr[3]); tbP1_ASR5.Text = Convert.ToString(sArr[4]); tbP1_ASR6.Text = Convert.ToString(sArr[5]); tbP1_ASR7.Text = Convert.ToString(sArr[6]); tbP1_ASR8.Text = Convert.ToString(sArr[7]); tbP1_ASR9.Text = Convert.ToString(sArr[8]); tbP1_ASR10.Text = Convert.ToString(sArr[9]); tbP1_ASR11.Text = Convert.ToString(sArr[10]); tbP1_ASR12.Text = Convert.ToString(sArr[11]); tbP1_ASR13.Text = Convert.ToString(sArr[12]); tbP1_ASR14.Text = Convert.ToString(sArr[13]); tbP1_ASR15.Text = Convert.ToString(sArr[14]); tbP1_ASR16.Text = Convert.ToString(sArr[15]); }
        private void DisplayP1_AMC(string[] sArr) { tbP1_AMC1.Text = Convert.ToString(sArr[0]); tbP1_AMC2.Text = Convert.ToString(sArr[1]); tbP1_AMC3.Text = Convert.ToString(sArr[2]); tbP1_AMC4.Text = Convert.ToString(sArr[3]); tbP1_AMC5.Text = Convert.ToString(sArr[4]); tbP1_AMC6.Text = Convert.ToString(sArr[5]); tbP1_AMC7.Text = Convert.ToString(sArr[6]); tbP1_AMC8.Text = Convert.ToString(sArr[7]); tbP1_AMC9.Text = Convert.ToString(sArr[8]); tbP1_AMC10.Text = Convert.ToString(sArr[9]); tbP1_AMC11.Text = Convert.ToString(sArr[10]); tbP1_AMC12.Text = Convert.ToString(sArr[11]); tbP1_AMC13.Text = Convert.ToString(sArr[12]); tbP1_AMC14.Text = Convert.ToString(sArr[13]); tbP1_AMC15.Text = Convert.ToString(sArr[14]); tbP1_AMC16.Text = Convert.ToString(sArr[15]); }
        private void DisplayP1_RK(string[] sArr) { tbP1_RK1.Text = Convert.ToString(sArr[0]); tbP1_RK2.Text = Convert.ToString(sArr[1]); tbP1_RK3.Text = Convert.ToString(sArr[2]); tbP1_RK4.Text = Convert.ToString(sArr[3]); tbP1_RK5.Text = Convert.ToString(sArr[4]); tbP1_RK6.Text = Convert.ToString(sArr[5]); tbP1_RK7.Text = Convert.ToString(sArr[6]); tbP1_RK8.Text = Convert.ToString(sArr[7]); tbP1_RK9.Text = Convert.ToString(sArr[8]); tbP1_RK10.Text = Convert.ToString(sArr[9]); tbP1_RK11.Text = Convert.ToString(sArr[10]); tbP1_RK12.Text = Convert.ToString(sArr[11]); tbP1_RK13.Text = Convert.ToString(sArr[12]); tbP1_RK14.Text = Convert.ToString(sArr[13]); tbP1_RK15.Text = Convert.ToString(sArr[14]); tbP1_RK16.Text = Convert.ToString(sArr[15]); }
        private void DisplayP1_C(string[] sArr) { tbP1_C1.Text = Convert.ToString(sArr[0]); tbP1_C2.Text = Convert.ToString(sArr[1]); tbP1_C3.Text = Convert.ToString(sArr[2]);tbP1_C4.Text = Convert.ToString(sArr[3]); tbP1_C5.Text = Convert.ToString(sArr[4]); tbP1_C6.Text = Convert.ToString(sArr[5]); tbP1_C7.Text = Convert.ToString(sArr[6]); tbP1_C8.Text = Convert.ToString(sArr[7]); tbP1_C9.Text = Convert.ToString(sArr[8]); tbP1_C10.Text = Convert.ToString(sArr[9]); tbP1_C11.Text = Convert.ToString(sArr[10]); tbP1_C12.Text = Convert.ToString(sArr[11]); tbP1_C13.Text = Convert.ToString(sArr[12]); tbP1_C14.Text = Convert.ToString(sArr[13]); tbP1_C15.Text = Convert.ToString(sArr[14]); tbP1_C16.Text = Convert.ToString(sArr[15]); }                                               
        private void DisplayP2(string[] sArr) { tbP2_1.Text = Convert.ToString(sArr[0]); tbP2_2.Text = Convert.ToString(sArr[1]); tbP2_3.Text = Convert.ToString(sArr[2]); tbP2_4.Text = Convert.ToString(sArr[3]); tbP2_5.Text = Convert.ToString(sArr[4]); tbP2_6.Text = Convert.ToString(sArr[5]); tbP2_7.Text = Convert.ToString(sArr[6]); tbP2_8.Text = Convert.ToString(sArr[7]); tbP2_9.Text = Convert.ToString(sArr[8]); tbP2_10.Text = Convert.ToString(sArr[9]); tbP2_11.Text = Convert.ToString(sArr[10]); tbP2_12.Text = Convert.ToString(sArr[11]); tbP2_13.Text = Convert.ToString(sArr[12]); tbP2_14.Text = Convert.ToString(sArr[13]); tbP2_15.Text = Convert.ToString(sArr[14]); tbP2_16.Text = Convert.ToString(sArr[15]); }
        private void DisplayP2_start(string[] sArr) { tbP2_start1.Text = Convert.ToString(sArr[0]); tbP2_start2.Text = Convert.ToString(sArr[1]); tbP2_start3.Text = Convert.ToString(sArr[2]); tbP2_start4.Text = Convert.ToString(sArr[3]); tbP2_start5.Text = Convert.ToString(sArr[4]); tbP2_start6.Text = Convert.ToString(sArr[5]); tbP2_start7.Text = Convert.ToString(sArr[6]); tbP2_start8.Text = Convert.ToString(sArr[7]); tbP2_start9.Text = Convert.ToString(sArr[8]); tbP2_start10.Text = Convert.ToString(sArr[9]); tbP2_start11.Text = Convert.ToString(sArr[10]); tbP2_start12.Text = Convert.ToString(sArr[11]); tbP2_start13.Text = Convert.ToString(sArr[12]); tbP2_start14.Text = Convert.ToString(sArr[13]); tbP2_start15.Text = Convert.ToString(sArr[14]); tbP2_start16.Text = Convert.ToString(sArr[15]);  }
        private void DisplayP2_ASB(string[] sArr) { tbP2_ASB1.Text = Convert.ToString(sArr[0]); tbP2_ASB2.Text = Convert.ToString(sArr[1]); tbP2_ASB3.Text = Convert.ToString(sArr[2]); tbP2_ASB4.Text = Convert.ToString(sArr[3]); tbP2_ASB5.Text = Convert.ToString(sArr[4]); tbP2_ASB6.Text = Convert.ToString(sArr[5]); tbP2_ASB7.Text = Convert.ToString(sArr[6]); tbP2_ASB8.Text = Convert.ToString(sArr[7]); tbP2_ASB9.Text = Convert.ToString(sArr[8]); tbP2_ASB10.Text = Convert.ToString(sArr[9]); tbP2_ASB11.Text = Convert.ToString(sArr[10]); tbP2_ASB12.Text = Convert.ToString(sArr[11]); tbP2_ASB13.Text = Convert.ToString(sArr[12]); tbP2_ASB14.Text = Convert.ToString(sArr[13]); tbP2_ASB15.Text = Convert.ToString(sArr[14]); tbP2_ASB16.Text = Convert.ToString(sArr[15]); }
        private void DisplayP2_ASR(string[] sArr) { tbP2_ASR1.Text = Convert.ToString(sArr[0]); tbP2_ASR2.Text = Convert.ToString(sArr[1]); tbP2_ASR3.Text = Convert.ToString(sArr[2]); tbP2_ASR4.Text = Convert.ToString(sArr[3]); tbP2_ASR5.Text = Convert.ToString(sArr[4]); tbP2_ASR6.Text = Convert.ToString(sArr[5]); tbP2_ASR7.Text = Convert.ToString(sArr[6]); tbP2_ASR8.Text = Convert.ToString(sArr[7]); tbP2_ASR9.Text = Convert.ToString(sArr[8]); tbP2_ASR10.Text = Convert.ToString(sArr[9]); tbP2_ASR11.Text = Convert.ToString(sArr[10]); tbP2_ASR12.Text = Convert.ToString(sArr[11]); tbP2_ASR13.Text = Convert.ToString(sArr[12]); tbP2_ASR14.Text = Convert.ToString(sArr[13]); tbP2_ASR15.Text = Convert.ToString(sArr[14]); tbP2_ASR16.Text = Convert.ToString(sArr[15]); }
        private void DisplayP2_AMC(string[] sArr) { tbP2_AMC1.Text = Convert.ToString(sArr[0]); tbP2_AMC2.Text = Convert.ToString(sArr[1]); tbP2_AMC3.Text = Convert.ToString(sArr[2]); tbP2_AMC4.Text = Convert.ToString(sArr[3]); tbP2_AMC5.Text = Convert.ToString(sArr[4]); tbP2_AMC6.Text = Convert.ToString(sArr[5]); tbP2_AMC7.Text = Convert.ToString(sArr[6]); tbP2_AMC8.Text = Convert.ToString(sArr[7]); tbP2_AMC9.Text = Convert.ToString(sArr[8]); tbP2_AMC10.Text = Convert.ToString(sArr[9]); tbP2_AMC11.Text = Convert.ToString(sArr[10]); tbP2_AMC12.Text = Convert.ToString(sArr[11]); tbP2_AMC13.Text = Convert.ToString(sArr[12]); tbP2_AMC14.Text = Convert.ToString(sArr[13]); tbP2_AMC15.Text = Convert.ToString(sArr[14]); tbP2_AMC16.Text = Convert.ToString(sArr[15]); }
        private void DisplayP2_RK(string[] sArr) { tbP2_RK1.Text = Convert.ToString(sArr[0]); tbP2_RK2.Text = Convert.ToString(sArr[1]); tbP2_RK3.Text = Convert.ToString(sArr[2]); tbP2_RK4.Text = Convert.ToString(sArr[3]); tbP2_RK5.Text = Convert.ToString(sArr[4]); tbP2_RK6.Text = Convert.ToString(sArr[5]); tbP2_RK7.Text = Convert.ToString(sArr[6]); tbP2_RK8.Text = Convert.ToString(sArr[7]); tbP2_RK9.Text = Convert.ToString(sArr[8]); tbP2_RK10.Text = Convert.ToString(sArr[9]); tbP2_RK11.Text = Convert.ToString(sArr[10]); tbP2_RK12.Text = Convert.ToString(sArr[11]); tbP2_RK13.Text = Convert.ToString(sArr[12]); tbP2_RK14.Text = Convert.ToString(sArr[13]); tbP2_RK15.Text = Convert.ToString(sArr[14]); tbP2_RK16.Text = Convert.ToString(sArr[15]); }
        private void DisplayP2_C(string[] sArr) { tbP2_C1.Text = Convert.ToString(sArr[0]); tbP2_C2.Text = Convert.ToString(sArr[1]); tbP2_C3.Text = Convert.ToString(sArr[2]); tbP2_C4.Text = Convert.ToString(sArr[3]); tbP2_C5.Text = Convert.ToString(sArr[4]); tbP2_C6.Text = Convert.ToString(sArr[5]); tbP2_C7.Text = Convert.ToString(sArr[6]); tbP2_C8.Text = Convert.ToString(sArr[7]); tbP2_C9.Text = Convert.ToString(sArr[8]); tbP2_C10.Text = Convert.ToString(sArr[9]); tbP2_C11.Text = Convert.ToString(sArr[10]); tbP2_C12.Text = Convert.ToString(sArr[11]); tbP2_C13.Text = Convert.ToString(sArr[12]); tbP2_C14.Text = Convert.ToString(sArr[13]); tbP2_C15.Text = Convert.ToString(sArr[14]); tbP2_C16.Text = Convert.ToString(sArr[15]); }

        private void ClearAll() {
            tbP1_1.Clear(); tbP1_2.Clear(); tbP1_3.Clear(); tbP1_4.Clear(); tbP1_5.Clear(); tbP1_6.Clear(); tbP1_7.Clear(); tbP1_8.Clear(); tbP1_9.Clear(); tbP1_10.Clear(); tbP1_11.Clear(); tbP1_12.Clear(); tbP1_13.Clear(); tbP1_14.Clear(); tbP1_15.Clear(); tbP1_16.Clear();
            tbP1_start1.Clear(); tbP1_start2.Clear(); tbP1_start3.Clear(); tbP1_start4.Clear(); tbP1_start5.Clear(); tbP1_start6.Clear(); tbP1_start7.Clear(); tbP1_start8.Clear(); tbP1_start9.Clear(); tbP1_start10.Clear(); tbP1_start11.Clear(); tbP1_start12.Clear(); tbP1_start13.Clear(); tbP1_start14.Clear(); tbP1_start15.Clear(); tbP1_start16.Clear();
            tbP1_ASB1.Clear(); tbP1_ASB2.Clear(); tbP1_ASB3.Clear(); tbP1_ASB4.Clear(); tbP1_ASB5.Clear(); tbP1_ASB6.Clear(); tbP1_ASB7.Clear(); tbP1_ASB8.Clear(); tbP1_ASB9.Clear(); tbP1_ASB10.Clear(); tbP1_ASB11.Clear(); tbP1_ASB12.Clear(); tbP1_ASB13.Clear(); tbP1_ASB14.Clear(); tbP1_ASB15.Clear(); tbP1_ASB16.Clear();
            tbP1_ASR1.Clear(); tbP1_ASR2.Clear(); tbP1_ASR3.Clear(); tbP1_ASR4.Clear(); tbP1_ASR5.Clear(); tbP1_ASR6.Clear(); tbP1_ASR7.Clear(); tbP1_ASR8.Clear(); tbP1_ASR9.Clear(); tbP1_ASR10.Clear(); tbP1_ASR11.Clear(); tbP1_ASR12.Clear(); tbP1_ASR13.Clear(); tbP1_ASR14.Clear(); tbP1_ASR15.Clear(); tbP1_ASR16.Clear();
            tbP1_AMC1.Clear(); tbP1_AMC2.Clear(); tbP1_AMC3.Clear(); tbP1_AMC4.Clear(); tbP1_AMC5.Clear(); tbP1_AMC6.Clear(); tbP1_AMC7.Clear(); tbP1_AMC8.Clear(); tbP1_AMC9.Clear(); tbP1_AMC10.Clear(); tbP1_AMC11.Clear(); tbP1_AMC12.Clear(); tbP1_AMC13.Clear(); tbP1_AMC14.Clear(); tbP1_AMC15.Clear(); tbP1_AMC16.Clear();
            tbP1_RK1.Clear(); tbP1_RK2.Clear(); tbP1_RK3.Clear(); tbP1_RK4.Clear(); tbP1_RK5.Clear(); tbP1_RK6.Clear(); tbP1_RK7.Clear(); tbP1_RK8.Clear(); tbP1_RK9.Clear(); tbP1_RK10.Clear(); tbP1_RK11.Clear(); tbP1_RK12.Clear(); tbP1_RK13.Clear(); tbP1_RK14.Clear(); tbP1_RK15.Clear(); tbP1_RK16.Clear();
            tbP1_C1.Clear(); tbP1_C2.Clear(); tbP1_C3.Clear(); tbP1_C4.Clear(); tbP1_C5.Clear(); tbP1_C6.Clear(); tbP1_C7.Clear(); tbP1_C8.Clear(); tbP1_C9.Clear(); tbP1_C10.Clear(); tbP1_C11.Clear(); tbP1_C12.Clear(); tbP1_C13.Clear(); tbP1_C14.Clear(); tbP1_C15.Clear(); tbP1_C16.Clear();
            
            tbP2_1.Clear(); tbP2_2.Clear(); tbP2_3.Clear(); tbP2_4.Clear(); tbP2_5.Clear(); tbP2_6.Clear(); tbP2_7.Clear(); tbP2_8.Clear(); tbP2_9.Clear(); tbP2_10.Clear(); tbP2_11.Clear(); tbP2_12.Clear(); tbP2_13.Clear(); tbP2_14.Clear(); tbP2_15.Clear(); tbP2_16.Clear();
            tbP2_start1.Clear(); tbP2_start2.Clear(); tbP2_start3.Clear(); tbP2_start4.Clear(); tbP2_start5.Clear(); tbP2_start6.Clear(); tbP2_start7.Clear(); tbP2_start8.Clear(); tbP2_start9.Clear(); tbP2_start10.Clear(); tbP2_start11.Clear(); tbP2_start12.Clear(); tbP2_start13.Clear(); tbP2_start14.Clear(); tbP2_start15.Clear(); tbP2_start16.Clear();
            tbP2_ASB1.Clear(); tbP2_ASB2.Clear(); tbP2_ASB3.Clear(); tbP2_ASB4.Clear(); tbP2_ASB5.Clear(); tbP2_ASB6.Clear(); tbP2_ASB7.Clear(); tbP2_ASB8.Clear(); tbP2_ASB9.Clear(); tbP2_ASB10.Clear(); tbP2_ASB11.Clear(); tbP2_ASB12.Clear(); tbP2_ASB13.Clear(); tbP2_ASB14.Clear(); tbP2_ASB15.Clear(); tbP2_ASB16.Clear();
            tbP2_ASR1.Clear(); tbP2_ASR2.Clear(); tbP2_ASR3.Clear(); tbP2_ASR4.Clear(); tbP2_ASR5.Clear(); tbP2_ASR6.Clear(); tbP2_ASR7.Clear(); tbP2_ASR8.Clear(); tbP2_ASR9.Clear(); tbP2_ASR10.Clear(); tbP2_ASR11.Clear(); tbP2_ASR12.Clear(); tbP2_ASR13.Clear(); tbP2_ASR14.Clear(); tbP2_ASR15.Clear(); tbP2_ASR16.Clear();
            tbP2_AMC1.Clear(); tbP2_AMC2.Clear(); tbP2_AMC3.Clear(); tbP2_AMC4.Clear(); tbP2_AMC5.Clear(); tbP2_AMC6.Clear(); tbP2_AMC7.Clear(); tbP2_AMC8.Clear(); tbP2_AMC9.Clear(); tbP2_AMC10.Clear(); tbP2_AMC11.Clear(); tbP2_AMC12.Clear(); tbP2_AMC13.Clear(); tbP2_AMC14.Clear(); tbP2_AMC15.Clear(); tbP2_AMC16.Clear();
            tbP2_RK1.Clear(); tbP2_RK2.Clear(); tbP2_RK3.Clear(); tbP2_RK4.Clear(); tbP2_RK5.Clear(); tbP2_RK6.Clear(); tbP2_RK7.Clear(); tbP2_RK8.Clear(); tbP2_RK9.Clear(); tbP2_RK10.Clear(); tbP2_RK11.Clear(); tbP2_RK12.Clear(); tbP2_RK13.Clear(); tbP2_RK14.Clear(); tbP2_RK15.Clear(); tbP2_RK16.Clear();
            tbP2_C1.Clear(); tbP2_C2.Clear(); tbP2_C3.Clear(); tbP2_C4.Clear(); tbP2_C5.Clear(); tbP2_C6.Clear(); tbP2_C7.Clear(); tbP2_C8.Clear(); tbP2_C9.Clear(); tbP2_C10.Clear(); tbP2_C11.Clear(); tbP2_C12.Clear(); tbP2_C13.Clear(); tbP2_C14.Clear(); tbP2_C15.Clear(); tbP2_C16.Clear();
        }
        private void ClearMixColumns() {
            tbP1_AMC1.Clear(); tbP1_AMC2.Clear(); tbP1_AMC3.Clear(); tbP1_AMC4.Clear(); tbP1_AMC5.Clear(); tbP1_AMC6.Clear(); tbP1_AMC7.Clear(); tbP1_AMC8.Clear(); tbP1_AMC9.Clear(); tbP1_AMC10.Clear(); tbP1_AMC11.Clear(); tbP1_AMC12.Clear(); tbP1_AMC13.Clear(); tbP1_AMC14.Clear(); tbP1_AMC15.Clear(); tbP1_AMC16.Clear();
            tbP2_AMC1.Clear(); tbP2_AMC2.Clear(); tbP2_AMC3.Clear(); tbP2_AMC4.Clear(); tbP2_AMC5.Clear(); tbP2_AMC6.Clear(); tbP2_AMC7.Clear(); tbP2_AMC8.Clear(); tbP2_AMC9.Clear(); tbP2_AMC10.Clear(); tbP2_AMC11.Clear(); tbP2_AMC12.Clear(); tbP2_AMC13.Clear(); tbP2_AMC14.Clear(); tbP2_AMC15.Clear(); tbP2_AMC16.Clear();
        }
        private void ClearShiftRows() {
            tbP1_ASR1.Clear(); tbP1_ASR2.Clear(); tbP1_ASR3.Clear(); tbP1_ASR4.Clear(); tbP1_ASR5.Clear(); tbP1_ASR6.Clear(); tbP1_ASR7.Clear(); tbP1_ASR8.Clear(); tbP1_ASR9.Clear(); tbP1_ASR10.Clear(); tbP1_ASR11.Clear(); tbP1_ASR12.Clear(); tbP1_ASR13.Clear(); tbP1_ASR14.Clear(); tbP1_ASR15.Clear(); tbP1_ASR16.Clear();
            tbP2_ASR1.Clear(); tbP2_ASR2.Clear(); tbP2_ASR3.Clear(); tbP2_ASR4.Clear(); tbP2_ASR5.Clear(); tbP2_ASR6.Clear(); tbP2_ASR7.Clear(); tbP2_ASR8.Clear(); tbP2_ASR9.Clear(); tbP2_ASR10.Clear(); tbP2_ASR11.Clear(); tbP2_ASR12.Clear(); tbP2_ASR13.Clear(); tbP2_ASR14.Clear(); tbP2_ASR15.Clear(); tbP2_ASR16.Clear();
        }        
        //####################################################################################################

        // Krypto functions ---------------------------------------------------------------------------------
        private string[] KeySchedule(string[] arr, string[] rconNum) {
            string[] rootWord1 = new string[4]; for (int i = 0; i < 4; i++) { rootWord1[i] = arr[i]; }
            string[] rootWord2 = new string[4]; for (int i = 0; i < 4; i++) { rootWord2[i] = arr[i + 4]; }
            string[] rootWord3 = new string[4]; for (int i = 0; i < 4; i++) { rootWord3[i] = arr[i + 8]; }
            string[] rootWord4 = new string[4]; for (int i = 0; i < 4; i++) { rootWord4[i] = arr[i + 12]; }
                        
            string[] flippedRootWord4 = new string[4];
            flippedRootWord4[0] = rootWord4[1];
            flippedRootWord4[1] = rootWord4[2];
            flippedRootWord4[2] = rootWord4[3];
            flippedRootWord4[3] = rootWord4[0];

            string[] subbedRootWord4 = new string[4];
            for (int i = 0; i < 4; i++) { subbedRootWord4[i] = subOne(flippedRootWord4[i]); }

            string[] keyArr1 = xor4x1Arr(xor4x1Arr(rootWord1, subbedRootWord4), rconNum);
            string[] keyArr2 = xor4x1Arr(rootWord2, keyArr1);
            string[] keyArr3 = xor4x1Arr(rootWord3, keyArr2);
            string[] keyArr4 = xor4x1Arr(rootWord4, keyArr3);

            string[] roundKey = new string[16];
            for (int i = 0; i < 4; i++) { roundKey[i] = keyArr1[i]; }
            for (int i = 0; i < 4; i++) { roundKey[i + 4] = keyArr2[i]; }
            for (int i = 0; i < 4; i++) { roundKey[i + 8] = keyArr3[i]; }
            for (int i = 0; i < 4; i++) { roundKey[i + 12] = keyArr4[i]; }

            return roundKey;
        }        
        private string subOne(string s) {
            char c1 = s[0]; char c2 = s[1];
            string prefix1 = c1.ToString(); string prefix2 = c2.ToString();
            int intValue1 = Convert.ToInt32(prefix1, 16); int intValue2 = Convert.ToInt32(prefix2, 16);
            return subByteTable[intValue1, intValue2];
        }
        private string[] SubByte(string[] arr) {
            string[] resultArr = new string[16];
            int i = 0;
            foreach (string s in arr) {
                char c1 = s[0]; char c2 = s[1];
                string prefix1 = c1.ToString(); string prefix2 = c2.ToString();
                int intValue1 = Convert.ToInt32(prefix1, 16); int intValue2 = Convert.ToInt32(prefix2, 16);

                string sub = subByteTable[intValue1, intValue2];
                resultArr[i] = sub;
                i++;
            }
            return resultArr;
        }
        private string[] ReverseSubByte(string[] arr) {
            string[] resultArr = new string[16];
            int i = 0;
            foreach (string s in arr) {
                char c1 = s[0]; char c2 = s[1];
                string prefix1 = c1.ToString(); string prefix2 = c2.ToString();
                int intValue1 = Convert.ToInt32(prefix1, 16); int intValue2 = Convert.ToInt32(prefix2, 16);

                string sub = inverseSubByteTable[intValue1, intValue2];
                resultArr[i] = sub;
                i++;
            }
            return resultArr;
        }
        private string[] ShiftRows(string[] arr) {
            // 00 05 10 15 04 09 14 03 08 13 02 07 12 01 06 11
            string[] shifted = new string[16];
            shifted[00] = arr[00];
            shifted[01] = arr[05];
            shifted[02] = arr[10];
            shifted[03] = arr[15];
            shifted[04] = arr[04];
            shifted[05] = arr[09];
            shifted[06] = arr[14];
            shifted[07] = arr[03];
            shifted[08] = arr[08];
            shifted[09] = arr[13];
            shifted[10] = arr[02];
            shifted[11] = arr[07];
            shifted[12] = arr[12];
            shifted[13] = arr[01];
            shifted[14] = arr[06];
            shifted[15] = arr[11];
            return shifted;
        }
        private string[] ReverseShiftRows(string[] arr) {
            //00 13 10 07 04 01 14 11 08 05 02 15 12 09 06 03             
            string[] shifted = new string[16];
            shifted[00] = arr[00];
            shifted[01] = arr[13];
            shifted[02] = arr[10];
            shifted[03] = arr[07];
            shifted[04] = arr[04];
            shifted[05] = arr[01];
            shifted[06] = arr[14];
            shifted[07] = arr[11];
            shifted[08] = arr[08];
            shifted[09] = arr[05];
            shifted[10] = arr[02];
            shifted[11] = arr[15];
            shifted[12] = arr[12];
            shifted[13] = arr[09];
            shifted[14] = arr[06];
            shifted[15] = arr[03];
            return shifted;
        }
        private string[] MixColumns(string[] arr) {
            string[] binArr = new string[16]; for (int i = 0; i < 16; i++) { binArr[i] = hexToBin(arr[i]); }
            string[] mixedColumns = new string[16];

            for (int i = 0; i < 16; i += 4) {
                string aBin = binArr[i];
                string bBin = binArr[i + 1];
                string cBin = binArr[i + 2];
                string dBin = binArr[i + 3];

                string r0 = XOR(XOR(XOR(Times02(aBin), Times03(bBin)), cBin), dBin);
                string r1 = XOR(XOR(XOR(aBin, Times02(bBin)), Times03(cBin)), dBin);
                string r2 = XOR(XOR(XOR(aBin, bBin), Times02(cBin)), Times03(dBin));
                string r3 = XOR(XOR(XOR(Times03(aBin), bBin), cBin), Times02(dBin));

                mixedColumns[i] = binToHex(r0);
                mixedColumns[i + 1] = binToHex(r1);
                mixedColumns[i + 2] = binToHex(r2);
                mixedColumns[i + 3] = binToHex(r3);

            }
            return mixedColumns;
        }
        private string[] ReverseMixColumns(string[] arr) {
            string[] binArr = new string[16]; for (int i = 0; i < 16; i++) { binArr[i] = hexToBin(arr[i]); }
            string[] mixedColumns = new string[16];

            for (int i = 0; i < 16; i += 4) {
                string aBin = binArr[i];
                string bBin = binArr[i + 1];
                string cBin = binArr[i + 2];
                string dBin = binArr[i + 3];

                string r0 = XOR(XOR(XOR(Times14(aBin), Times11(bBin)), Times13(cBin)), Times09(dBin));
                string r1 = XOR(XOR(XOR(Times09(aBin), Times14(bBin)), Times11(cBin)), Times13(dBin));
                string r2 = XOR(XOR(XOR(Times13(aBin), Times09(bBin)), Times14(cBin)), Times11(dBin));
                string r3 = XOR(XOR(XOR(Times11(aBin), Times13(bBin)), Times09(cBin)), Times14(dBin));

                mixedColumns[i] = binToHex(r0);
                mixedColumns[i + 1] = binToHex(r1);
                mixedColumns[i + 2] = binToHex(r2);
                mixedColumns[i + 3] = binToHex(r3);
            }
            return mixedColumns;
        }
        private string[] MakeC1_mark(string[] c1, string[] c2) {
            string[] mark = new string[16];
            for (int i = 0; i < 16; i++) {
                if (i < 4) { mark[i] = c2[i]; }
                else { mark[i] = c1[i]; }
            }
            return mark;
        }
        private string[] MakeC2_mark(string[] c1, string[] c2) {
            string[] mark = new string[16];
            for (int i = 0; i < 16; i++) {
                if (i < 4) { mark[i] = c1[i]; }
                else { mark[i] = c2[i]; }
            }
            return mark;
        }
        // Encryption ------------------------------------------------------------------------------------------                
        private string[] EncryptAllRounds(string[] p, string[] k) {
            List<string[]> rkList = new List<string[]>();
            string[] rk = new string[16];
            for (int i = 0; i < 10; i++) { // KeySchedule
                if (i == 0) { rk = KeySchedule(k, rconList[0]); rkList.Add(rk); }
                else { rk = KeySchedule(rk, rconList[i]); rkList.Add(rk); }
            }                        
            string[] state = xor4x4Arr(p, k);
            for (int i = 0; i < 10; i++) {
                if (i < 9) {
                    state = SubByte(state);
                    state = ShiftRows(state);
                    state = MixColumns(state);
                    state = xor4x4Arr(state, rkList[i]);
                }
                else {
                    state = SubByte(state);
                    state = ShiftRows(state);
                    state = xor4x4Arr(state, rkList[i]);
                }                
            }
            return state;
        }
        private string[] Encrypt4AdaptiveRounds(string[] p, string[] k) {
            List<string[]> rkList = new List<string[]>();
            string[] rk = new string[16];
            for (int i = 0; i < 10; i++) { // KeySchedule
                if (i == 0) { rk = KeySchedule(k, rconList[0]); rkList.Add(rk); }
                else { rk = KeySchedule(rk, rconList[i]); rkList.Add(rk); }
            }
            string[] state = xor4x4Arr(p, k);
            for (int i = 0; i < 4; i++) {
                state = SubByte(state);
                state = xor4x4Arr(state, rkList[i]);
            }
            return state;
        }
        
        private string[] EncryptP1_OneRound(string[] state, string[] rk) {
                                            DisplayP1_start(state);
            state = SubByte(state);         DisplayP1_ASB(state);
            state = ShiftRows(state);       DisplayP1_ASR(state);
            state = MixColumns(state);      DisplayP1_AMC(state);
                                            DisplayP1_RK(rk);
            state = xor4x4Arr(state, rk);   DisplayP1_C(state);
            return state;
        }
        private string[] EncryptP1_LastRound(string[] state, string[] rk) {
                                            DisplayP1_start(state);
            state = SubByte(state);         DisplayP1_ASB(state);
            state = ShiftRows(state);       DisplayP1_ASR(state);
            //state = MixColumns(state);    DisplayP1_AMC(state);            
                                            DisplayP1_RK(rk);
            state = xor4x4Arr(state, rk);   DisplayP1_C(state);
            return state;
        }

        private string[] EncryptP2_OneRound(string[] state, string[] rk) {
                                            DisplayP2_start(state);
            state = SubByte(state);         DisplayP2_ASB(state);
            state = ShiftRows(state);       DisplayP2_ASR(state);
            state = MixColumns(state);      DisplayP2_AMC(state);
                                            DisplayP2_RK(state);
            state = xor4x4Arr(state, rk);   DisplayP2_C(state);
            return state;
        }
        private string[] EncryptP2_LastRound(string[] state, string[] rk) {
                                            DisplayP2_start(state);
            state = SubByte(state);         DisplayP2_ASB(state);
            state = ShiftRows(state);       DisplayP2_ASR(state);
            //state = MixColumns(state);    DisplayP2_AMC(state);
                                            DisplayP2_RK(rk);
            state = xor4x4Arr(state, rk);   DisplayP2_C(state);
            return state;
        }

        private string[] EncryptP1_OneRoundWithoutSRandMR(string[] state, string[] rk) {
                                            DisplayP1_start(state);
            state = SubByte(state);         DisplayP1_ASB(state);
            //state = ShiftRows(state);     DisplayP1_ASR(state);
            //state = MixColumns(state);    DisplayP1_AMC(state);
                                            DisplayP1_RK(rk);
            state = xor4x4Arr(state, rk);   DisplayP1_C(state);
            return state;
        }
        private string[] EncryptP2_OneRoundWithoutSRandMR(string[] state, string[] rk) {
                                            DisplayP2_start(state);
            state = SubByte(state);         DisplayP2_ASB(state);
            //state = ShiftRows(state);     DisplayP2_ASR(state);
            //state = MixColumns(state);    DisplayP2_AMC(state);
                                            DisplayP2_RK(rk);
            state = xor4x4Arr(state, rk);   DisplayP2_C(state);
            return state;
        }
        

        // Decrytion ------------------------------------------------------------------------------------------                
        private string[] DecryptAllRounds(string[] c, string[] k) {
            List<string[]> rkList = new List<string[]>();
            string[] rk = new string[16];
            for (int i = 0; i < 10; i++) { // KeySchedule
                if (i == 0) { rk = KeySchedule(k, rconList[0]); rkList.Add(rk); }
                else { rk = KeySchedule(rk, rconList[i]); rkList.Add(rk); }
            }
            string[] state = new string[16];
            for (int i = 9; i >= 0; i--) {                
                if (i == 9) {
                    state = xor4x4Arr(rkList[i], c);
                    state = ReverseShiftRows(state);
                    state = ReverseSubByte(state);
                }
                else {
                    state = xor4x4Arr(rkList[i], state);
                    state = ReverseMixColumns(state);
                    state = ReverseShiftRows(state);
                    state = ReverseSubByte(state);
                }
            }
            state = xor4x4Arr(state, k);
            return state;
        }
        private string[] Decrypt4AdaptiveRounds(string[] c, string[] k) {
            List<string[]> rkList = new List<string[]>();
            string[] rk = new string[16];
            for (int i = 0; i < 10; i++) { // KeySchedule
                if (i == 0) { rk = KeySchedule(k, rconList[0]); rkList.Add(rk); }
                else { rk = KeySchedule(rk, rconList[i]); rkList.Add(rk); }
            }
            string[] state = new string[16];
            for (int i = 3; i >= 0; i--) {
                if (i == 3) {
                    state = xor4x4Arr(rkList[i], c);
                    state = ReverseSubByte(state);
                }
                else {
                    state = xor4x4Arr(rkList[i], state);
                    state = ReverseSubByte(state);
                }
                
            }
            state = xor4x4Arr(state, k);
            return state;
        }

        private string[] DecryptP1_LastRound(string[] state, string[] rk) {
                                                DisplayP1_RK(rk);
            state = xor4x4Arr(state, rk);       DisplayP1_ASR(state);
            state = ReverseShiftRows(state);    DisplayP1_ASB(state);
            state = ReverseSubByte(state);      DisplayP1_start(state);
            return state;
        }
        private string[] DecryptP1_OneRound(string[] state, string[] rk) {
                                                DisplayP1_RK(rk);
            state = xor4x4Arr(state, rk);       DisplayP1_AMC(state);
            state = ReverseMixColumns(state);   DisplayP1_ASR(state);
            state = ReverseShiftRows(state);    DisplayP1_ASB(state);
            state = ReverseSubByte(state);      DisplayP1_start(state);
            return state;
        }

        private string[] DecryptP2_LastRound(string[] state, string[] rk) {
                                                DisplayP2_RK(rk);
            state = xor4x4Arr(state, rk);       DisplayP2_ASR(state);
            state = ReverseShiftRows(state);    DisplayP2_ASB(state);
            state = ReverseSubByte(state);      DisplayP2_start(state);
            return state;
        }
        private string[] DecryptP2_OneRound(string[] state, string[] rk) {
                                                DisplayP2_RK(rk);
            state = xor4x4Arr(state, rk);       DisplayP2_AMC(state);
            state = ReverseMixColumns(state);   DisplayP2_ASR(state);
            state = ReverseShiftRows(state);    DisplayP2_ASB(state);
            state = ReverseSubByte(state);      DisplayP2_start(state);
            return state;
        }

        private string[] DecryptP1_OneRoundWithoutSRandMR(string[] state, string[] rk) {
                                                DisplayP1_RK(rk);
            state = xor4x4Arr(state, rk);     //DisplayP1_ASR(state);
            //state = ReverseShiftRows(state);  
                                                DisplayP1_ASB(state);
            state = ReverseSubByte(state);      DisplayP1_start(state);
            return state;
        }
        private string[] DecryptP2_OneRoundWithoutSRandMR(string[] state, string[] rk) {
                                                DisplayP2_RK(rk);
            state = xor4x4Arr(state, rk);     //DisplayP2_ASR(state);
            //state = ReverseShiftRows(state);  DisplayP1_ASB(state);
                                                DisplayP2_ASB(state);
            state = ReverseSubByte(state);      DisplayP2_start(state);
            return state;
        }
                        
        //####################################################################################################
        private void Adaptiv4RoundEncodeDecode(string[] p1, string[] p2, string[] k) {
            ClearAll(); roundCounter = 0; roundKeyList.Clear();
            
            string[] rk = new string[16];
            for (int i = 0; i < 10; i++) {
                if (i == 0) { rk = KeySchedule(k, rconList[0]); roundKeyList.Add(rk); }
                else { rk = KeySchedule(rk, rconList[i]); roundKeyList.Add(rk); }
            }
            DisplayP1(p1); DisplayP2(p2);

            c1Arr = Encrypt4AdaptiveRounds(p1, k); textBoxC1.Text = printArr(c1Arr);
            c2Arr = Encrypt4AdaptiveRounds(p2, k); textBoxC2.Text = printArr(c2Arr);

            c1_markArr = MakeC1_mark(c1Arr, c2Arr); textBoxC1_mark.Text = printArr(c1_markArr); DisplayP1_C(c1_markArr);
            c2_markArr = MakeC2_mark(c1Arr, c2Arr); textBoxC2_mark.Text = printArr(c2_markArr); DisplayP2_C(c2_markArr);

            p1_markArr = Decrypt4AdaptiveRounds(c1_markArr, k); textBoxP1_mark.Text = printArr(p1_markArr); DisplayP1(p1_markArr);
            p2_markArr = Decrypt4AdaptiveRounds(c2_markArr, k); textBoxP2_mark.Text = printArr(p2_markArr); DisplayP2(p2_markArr);
        }

        //####################################################################################################

        // Generation
        private string[] GenerateDiagonalMatrix(uint _uint) { //uint 0 -> 2^32    0 -> 4294967295
            string[] matrix = new string[16];
            //Diagonal:   0, 5, 10, 15
            string hexString = uintToHex(_uint); // 12345678
            string[] diagonal = new string[4];
            diagonal = init32BitStringArray(hexString);
            
            for (int i = 0; i < 16; i++) {
                if (i == 0) { matrix[i] = diagonal[0]; }
                else if (i == 5) { matrix[i] = diagonal[1]; }
                else if (i == 10) { matrix[i] = diagonal[2]; }
                else if (i == 15) { matrix[i] = diagonal[3]; }
                else { matrix[i] = "00"; }                
            }            
            return matrix;
        }
        private string[] GenerateDoubleDiagonalMatrix(uint _uint1, uint _uint2) {
            string[] matrix = new string[16];
            //Diagonal1:  0, 5, 10, 15
            //Diagonal2:  4, 9, 14, 3
            string hexString1 = uintToHex(_uint1);
            string hexString2 = uintToHex(_uint2);
            string[] diagonal1 = init32BitStringArray(hexString1);
            string[] diagonal2 = init32BitStringArray(hexString2);

            for (int i = 0; i < 16; i++) {
                //Diagonal1
                if (i == 0) { matrix[i] = diagonal1[0]; }                
                else if (i == 5) { matrix[i] = diagonal1[1]; }
                else if (i == 10) { matrix[i] = diagonal1[2]; }
                else if (i == 15) { matrix[i] = diagonal1[3]; }
                //Diagonal2
                else if (i == 4) { matrix[i] = diagonal2[0]; }
                else if (i == 9) { matrix[i] = diagonal2[1]; }
                else if (i == 14) { matrix[i] = diagonal2[2]; }
                else if (i == 3) { matrix[i] = diagonal2[3]; }
                //rest
                else { matrix[i] = "00"; }                  
            }
            return matrix;
        }        
        private bool isSomeColumnsTheSame(string[] matrix1, string[] matrix2) {
            string[] m1c1 = new string[4];
            string[] m1c2 = new string[4];
            string[] m1c3 = new string[4];
            string[] m1c4 = new string[4];
            for (int i = 0; i < 16; i++) {
                if (i <= 0 && i >= 3) { m1c1[i] = matrix1[i]; }
                else if (i <= 4 && i >= 7) { m1c2[i] = matrix1[i]; }
                else if (i <= 8 && i >= 11) { m1c3[i] = matrix1[i]; }
                else if (i <= 12 && i >= 15) { m1c4[i] = matrix1[i]; }
            }
            string[] m2c1 = new string[4];
            string[] m2c2 = new string[4];
            string[] m2c3 = new string[4];
            string[] m2c4 = new string[4];
            for (int i = 0; i < 16; i++) {
                if (i <= 0 && i >= 3) { m2c1[i] = matrix2[i]; }
                else if (i <= 4 && i >= 7) { m2c2[i] = matrix2[i]; }
                else if (i <= 8 && i >= 11) { m2c3[i] = matrix2[i]; }
                else if (i <= 12 && i >= 15) { m2c4[i] = matrix2[i]; }
            }
            if (m1c1 == m2c1) { return true; }
            else if (m1c2 == m2c2) { return true; }
            else if (m1c3 == m2c3) { return true; }
            else if (m1c4 == m2c4) { return true; }
            else { return false; }                        
        }
        private string[] SwapDiagonalsInMatrix(string[] matrix) {
            string[] newMatrix = new string[16]; //now inverting the two diagonals                        
            string[] diagonal2 = new string[4] { matrix[0], matrix[5], matrix[10], matrix[15] }; //Diagonal1:  0, 5, 10, 15
            string[] diagonal1 = new string[4] { matrix[4], matrix[9], matrix[14], matrix[3] };  //Diagonal2:  4, 9, 14, 3
            for (int i = 0; i < 16; i++) {
                //Diagonal1
                if (i == 0) { newMatrix[i] = diagonal1[0]; }
                else if (i == 5) { newMatrix[i] = diagonal1[1]; }
                else if (i == 10) { newMatrix[i] = diagonal1[2]; }
                else if (i == 15) { newMatrix[i] = diagonal1[3]; }
                //Diagonal2
                else if (i == 4) { newMatrix[i] = diagonal2[0]; }
                else if (i == 9) { newMatrix[i] = diagonal2[1]; }
                else if (i == 14) { newMatrix[i] = diagonal2[2]; }
                else if (i == 3) { newMatrix[i] = diagonal2[3]; }
                //rest
                else { newMatrix[i] = matrix[i]; }                        
            }
            return newMatrix;
        }



        //----------------------------------------------------------------------------------------
        // Buttons --------------------------------------------------------------------------------
        private void btnReadyEncrypt_Click(object sender, EventArgs e) {
            ClearAll(); roundCounter = 0; roundKeyList.Clear();
            try {
                if (IsValidInput(textBoxP1.Text.ToString()) && IsValidInput(textBoxP1.Text.ToString()) && IsValidInput(textBoxKey.Text.ToString())) {
                    p1Arr = initStringArray(textBoxP1.Text.ToString());
                    p2Arr = initStringArray(textBoxP2.Text.ToString());
                    keyArr = initStringArray(textBoxKey.Text.ToString());
                }
                else { MessageBox.Show("Not Valid input"); }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message); }
                        
            string[] rk = new string[16];
            for (int i = 0; i < 10; i++) {
                if (i == 0) { rk = KeySchedule(keyArr, rconList[0]); roundKeyList.Add(rk); }
                else { rk = KeySchedule(rk, rconList[i]); roundKeyList.Add(rk); }
            }             
            DisplayP1(p1Arr); DisplayP2(p2Arr);
        }
        private void btnEncrypt_Click(object sender, EventArgs e) {
            try {
                if (IsValidInput(textBoxP1.Text.ToString()) && IsValidInput(textBoxP1.Text.ToString()) && IsValidInput(textBoxKey.Text.ToString())) {
                    p1Arr = initStringArray(textBoxP1.Text.ToString());
                    p2Arr = initStringArray(textBoxP2.Text.ToString());
                    keyArr = initStringArray(textBoxKey.Text.ToString());
                }
                else { MessageBox.Show("Not Valid input"); }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message); }

            c1Arr = EncryptAllRounds(p1Arr, keyArr); textBoxC1.Text = printArr(c1Arr);
            c2Arr = EncryptAllRounds(p2Arr, keyArr); textBoxC2.Text = printArr(c2Arr);
        }
        private void btnEncryptOneRound_Click(object sender, EventArgs e) {            
            if (roundCounter == 0) {
                p1State = xor4x4Arr(p1Arr, keyArr);
                p2State = xor4x4Arr(p2Arr, keyArr);  
            }
            if (roundCounter < 9) {
                p1State = EncryptP1_OneRound(p1State, roundKeyList[roundCounter]);
                p2State = EncryptP2_OneRound(p2State, roundKeyList[roundCounter]);
                roundCounter++;
                labelRoundCounter.Text = "Round " + roundCounter;
            }
            else if (roundCounter == 9) {
                p1State = EncryptP1_LastRound(p1State, roundKeyList[roundCounter]);
                p2State = EncryptP2_LastRound(p2State, roundKeyList[roundCounter]);
                ClearMixColumns();
                c1Arr = p1State; textBoxC1.Text = printArr(c1Arr);
                c2Arr = p2State; textBoxC2.Text = printArr(c2Arr);
                roundCounter++;
                labelRoundCounter.Text = "Round " + roundCounter;
            }            
        }                
        private void btnWalkAdaptive4Round_Click(object sender, EventArgs e) {
            if (roundCounter == 0) {
                p1State = xor4x4Arr(p1Arr, keyArr);
                p2State = xor4x4Arr(p2Arr, keyArr);
            }
            /*if (roundCounter < 3) {
                p1State = EncryptP1_OneRound(p1State, roundKeyList[roundCounter]);
                p2State = EncryptP2_OneRound(p2State, roundKeyList[roundCounter]);
                roundCounter++;
                labelRoundCounter.Text = "Round " + roundCounter;
            }*/
            if (roundCounter < 3) {
                p1State = EncryptP1_OneRoundWithoutSRandMR(p1State, roundKeyList[roundCounter]);
                p2State = EncryptP2_OneRoundWithoutSRandMR(p2State, roundKeyList[roundCounter]);
                roundCounter++;
                labelRoundCounter.Text = "Round " + roundCounter;
            }
            else if (roundCounter == 3) {
                p1State = EncryptP1_OneRoundWithoutSRandMR(p1State, roundKeyList[roundCounter]);
                p2State = EncryptP2_OneRoundWithoutSRandMR(p2State, roundKeyList[roundCounter]);
                ClearShiftRows(); ClearMixColumns();
                c1Arr = p1State; textBoxC1.Text = printArr(c1Arr);
                c2Arr = p2State; textBoxC2.Text = printArr(c2Arr);
                roundCounter++;
                labelRoundCounter.Text = "Round " + roundCounter;
            }            
        }


        private void btnReadyDecrypt_Click(object sender, EventArgs e) {
            ClearAll(); roundCounter = 9; roundKeyList.Clear();
            try {
                if (IsValidInput(textBoxC1_mark.Text.ToString()) && IsValidInput(textBoxC2_mark.Text.ToString()) && IsValidInput(textBoxKey.Text.ToString())) {
                    c1_markArr = initStringArray(textBoxC1_mark.Text.ToString());
                    c2_markArr = initStringArray(textBoxC2_mark.Text.ToString());
                    keyArr = initStringArray(textBoxKey.Text.ToString());
                }
                else { MessageBox.Show("Not Valid input"); }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message); }
                        
            string[] rk = new string[16];
            for (int i = 0; i < 10; i++) {
                if (i == 0) { rk = KeySchedule(keyArr, rconList[0]); roundKeyList.Add(rk); }
                else { rk = KeySchedule(rk, rconList[i]); roundKeyList.Add(rk); }
            }
            DisplayP1_C(c1_markArr); DisplayP2_C(c2_markArr);
            
        }
        private void btnReady4Decrypt_Click(object sender, EventArgs e) {
            ClearAll(); roundCounter = 3; roundKeyList.Clear();
            try {
                if (IsValidInput(textBoxC1_mark.Text.ToString()) && IsValidInput(textBoxC2_mark.Text.ToString()) && IsValidInput(textBoxKey.Text.ToString())) {
                    c1_markArr = initStringArray(textBoxC1_mark.Text.ToString());
                    c2_markArr = initStringArray(textBoxC2_mark.Text.ToString());
                    keyArr = initStringArray(textBoxKey.Text.ToString());
                }
                else { MessageBox.Show("Not Valid input"); }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message); }

            string[] rk = new string[16];
            for (int i = 0; i < 10; i++) {
                if (i == 0) { rk = KeySchedule(keyArr, rconList[0]); roundKeyList.Add(rk); }
                else { rk = KeySchedule(rk, rconList[i]); roundKeyList.Add(rk); }
            }
            DisplayP1_C(c1_markArr); DisplayP2_C(c2_markArr);
        }
        private void btnDecrypt_Click(object sender, EventArgs e) {
            try {
                if (IsValidInput(textBoxC1_mark.Text.ToString()) && IsValidInput(textBoxC2_mark.Text.ToString()) && IsValidInput(textBoxKey.Text.ToString())) {
                    c1_markArr = initStringArray(textBoxC1_mark.Text.ToString());
                    c2_markArr = initStringArray(textBoxC2_mark.Text.ToString());
                    keyArr = initStringArray(textBoxKey.Text.ToString());
                }
                else { MessageBox.Show("Not Valid input"); }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message); }

            p1_markArr = DecryptAllRounds(c1_markArr, keyArr); textBoxP1_mark.Text = printArr(p1_markArr);
            p2_markArr = DecryptAllRounds(c2_markArr, keyArr); textBoxP2_mark.Text = printArr(p2_markArr);
        }
        private void btnDecryptOneRound_Click(object sender, EventArgs e) {            
            if (roundCounter == 9) {                
                c1State = DecryptP1_LastRound(c1_markArr, roundKeyList[roundCounter]);
                c2State = DecryptP2_LastRound(c2_markArr, roundKeyList[roundCounter]);                
                labelRoundCounter.Text = "Round " + (roundCounter + 1);
                roundCounter--;
            }
            else if (roundCounter > 0) {
                c1State = DecryptP1_OneRound(c1State, roundKeyList[roundCounter]);
                c2State = DecryptP2_OneRound(c2State, roundKeyList[roundCounter]);
                labelRoundCounter.Text = "Round " + (roundCounter + 1);
                roundCounter--;
            }
            else if (roundCounter == 0) {
                c1State = DecryptP1_OneRound(c1State, roundKeyList[roundCounter]);
                c2State = DecryptP2_OneRound(c2State, roundKeyList[roundCounter]);
                
                p1Arr = c1State; textBoxP1_mark.Text = printArr(p1Arr);
                p2Arr = c2State; textBoxP2_mark.Text = printArr(p2Arr);                
                labelRoundCounter.Text = "Round " + (roundCounter + 1);
                roundCounter--;
            }
            DisplayP1(c1State); DisplayP2(c2State);
        }
        private void btnWalkAdaptive4RoundDecrypt_Click(object sender, EventArgs e) {
            if (roundCounter == 3) {
                c1State = DecryptP1_OneRoundWithoutSRandMR(c1_markArr, roundKeyList[roundCounter]);
                c2State = DecryptP2_OneRoundWithoutSRandMR(c2_markArr, roundKeyList[roundCounter]);
                labelRoundCounter.Text = "Round " + (roundCounter + 1);
                roundCounter--;
            }            
            else if (roundCounter > 0) {
                c1State = DecryptP1_OneRoundWithoutSRandMR(c1State, roundKeyList[roundCounter]);
                c2State = DecryptP2_OneRoundWithoutSRandMR(c2State, roundKeyList[roundCounter]);
                labelRoundCounter.Text = "Round " + (roundCounter + 1);
                roundCounter--;
            }
            else if (roundCounter == 0) {
                c1State = DecryptP1_OneRoundWithoutSRandMR(c1State, roundKeyList[roundCounter]);
                c2State = DecryptP2_OneRoundWithoutSRandMR(c2State, roundKeyList[roundCounter]);

                p1Arr = c1State; textBoxP1_mark.Text = printArr(p1Arr);
                p2Arr = c2State; textBoxP2_mark.Text = printArr(p2Arr);
                labelRoundCounter.Text = "Round " + (roundCounter + 1);
                roundCounter--;
            }
            DisplayP1(c1State); DisplayP2(c2State);
        }

        private void btnMakeC1_mark_and_C2_mark_Click(object sender, EventArgs e) {            
            try {
                if (IsValidInput(textBoxC1.Text.ToString()) && IsValidInput(textBoxC2.Text.ToString()) ) {
                    c1Arr = initStringArray(textBoxC1.Text.ToString());
                    c2Arr = initStringArray(textBoxC2.Text.ToString());                    
                }
                else { MessageBox.Show("Not Valid input"); }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message); }

            c1_markArr = MakeC1_mark(c1Arr, c2Arr);
            c2_markArr = MakeC2_mark(c1Arr, c2Arr);

            textBoxC1_mark.Text = printArr(c1_markArr);
            textBoxC2_mark.Text = printArr(c2_markArr);
        }

                        
        private void btn4RoundAdaptive_Click(object sender, EventArgs e) {
            ClearAll(); roundCounter = 0; roundKeyList.Clear();
            try {
                if (IsValidInput(textBoxP1.Text.ToString()) && IsValidInput(textBoxP1.Text.ToString()) && IsValidInput(textBoxKey.Text.ToString())) {
                    p1Arr = initStringArray(textBoxP1.Text.ToString());
                    p2Arr = initStringArray(textBoxP2.Text.ToString());
                    keyArr = initStringArray(textBoxKey.Text.ToString());
                }
                else { MessageBox.Show("Not Valid input"); }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message); }

            string[] rk = new string[16];
            for (int i = 0; i < 10; i++) {
                if (i == 0) { rk = KeySchedule(keyArr, rconList[0]); roundKeyList.Add(rk); }
                else { rk = KeySchedule(rk, rconList[i]); roundKeyList.Add(rk); }
            }
            DisplayP1(p1Arr); DisplayP2(p2Arr);

            c1Arr = Encrypt4AdaptiveRounds(p1Arr, keyArr); textBoxC1.Text = printArr(c1Arr);
            c2Arr = Encrypt4AdaptiveRounds(p2Arr, keyArr); textBoxC2.Text = printArr(c2Arr);

            c1_markArr = MakeC1_mark(c1Arr, c2Arr); textBoxC1_mark.Text = printArr(c1_markArr); DisplayP1_C(c1_markArr);
            c2_markArr = MakeC2_mark(c1Arr, c2Arr); textBoxC2_mark.Text = printArr(c2_markArr); DisplayP2_C(c2_markArr);

            p1_markArr = Decrypt4AdaptiveRounds(c1_markArr, keyArr); textBoxP1_mark.Text = printArr(p1_markArr); DisplayP1(p1_markArr);
            p2_markArr = Decrypt4AdaptiveRounds(c2_markArr, keyArr); textBoxP2_mark.Text = printArr(p2_markArr); DisplayP2(p2_markArr);
        }

        private void btnGenerateDiagonal_Click(object sender, EventArgs e) {
            List<string[]> pList = new List<string[]>();
            List<string[]> cList = new List<string[]>();

            Dictionary<int, string[]> cDictionary = new Dictionary<int, string[]>();
                        
            diagonal1GeneratorCounter = 100000;
            diagonal2GeneratorCounter = 100000;         
            string[] k = initStringArray("00000000000000000000000000000000");
            string[] p = new string[16];
            string[] c = new string[16];
            for (int i = 0; i < 100; i++) { //65535 2^16
                p = GenerateDoubleDiagonalMatrix(diagonal1GeneratorCounter, diagonal2GeneratorCounter);   
                c = Encrypt4AdaptiveRounds(p, k);
                textBoxConsole.AppendText(printArr(c) + " " +  i.ToString() + "\r\n");
                pList.Add(p); cList.Add(c);
                /*if (i == 50) { cDictionary.Add(i, cList[i-1]); }
                else if (i == 75) { cDictionary.Add(i, cList[i - 1]); }
                else if (i == 77) { cDictionary.Add(i, cList[i - 3]); }
                else if (i == 79) { cDictionary.Add(i, cList[i - 5]); }
                else { cDictionary.Add(i, c); }*/
                cDictionary.Add(i, c);          
                diagonal1GeneratorCounter += 1234; diagonal2GeneratorCounter += 876;
            }            
            //var result = from po in cDictionary group po by po.Value into g where g.Count() > 1 select g;
            //var result = from po in cDictionary group po by printArr(po.Value) into g where g.Count() > 1 select g;

            var col1 = from po in cDictionary group po by printArr(po.Value).Substring(0, 8) into g where g.Count() > 1 select g;
            var col2 = from po in cDictionary group po by printArr(po.Value).Substring(8, 8) into g where g.Count() > 1 select g;
            var col3 = from po in cDictionary group po by printArr(po.Value).Substring(16, 8) into g where g.Count() > 1 select g;
            var col4 = from po in cDictionary group po by printArr(po.Value).Substring(24, 8) into g where g.Count() > 1 select g;

            textBoxConsole.AppendText("\r\nColumn 1 same values:");
            foreach (var item in col1) { 
                var sameValue = (from pop in item select pop.Key).ToArray();                                                
                textBoxConsole.AppendText("\r\n" + item.Key + " : "); foreach (var v in sameValue) { textBoxConsole.AppendText(v + ", "); }
            }
            textBoxConsole.AppendText("\r\n\r\nColumn 2 same values:");
            foreach (var item in col2) {
                var sameValue = (from pop in item select pop.Key).ToArray();
                textBoxConsole.AppendText("\r\n" + item.Key + " : "); foreach (var v in sameValue) { textBoxConsole.AppendText(v + ", "); }
            }
            textBoxConsole.AppendText("\r\n\r\nColumn 3 same values:");
            foreach (var item in col3) {
                var sameValue = (from pop in item select pop.Key).ToArray();
                textBoxConsole.AppendText("\r\n" + item.Key + " : "); foreach (var v in sameValue) { textBoxConsole.AppendText(v + ", "); }
            }
            textBoxConsole.AppendText("\r\n\r\nColumn 4 same values:");
            foreach (var item in col4) {
                var sameValue = (from pop in item select pop.Key).ToArray();
                textBoxConsole.AppendText("\r\n" + item.Key + " : "); foreach (var v in sameValue) { textBoxConsole.AppendText(v + ", "); }
            }
            
        }

        





    }    
}
